/* This LYNX frontend is intended to allow
   use of LYNX as a browser from Lotus Notes.
   Lotus Notes cannot launch the runlynx.cmd script
   since it is not an exe file.
   This program starts RUNLYNX.CMD passing it
    the url from Notes.
    Then it brings LYNX session to foreground. */

#define INCL_WIN
#define INCL_PM
  #define INCL_DOSPROCESS
#define INCL_BASE
#include <os2emx.h>
#include <OS2.H>
#include <string.h>
#include <io.h>
#include <STDLIB.H>
#include <STDIO.H>

     char msgtext[240];

void presentation(char *pgm);
int switchto( char *sw_title);
     void msgbox( char *msg);

int main(int argc, char *argv[]) {
  char exefile[CCHMAXPATH];
  char parms[256] = "\0";
  char cmd[256];
  char *dir;
  int i;
  APIRET rc;
  PPIB ppib;
  PTIB ptib;

  presentation( argv[0]);

  /* Get the directory in which we are running */
  DosGetInfoBlocks(&ptib,&ppib);
  rc=DosQueryModuleName(ppib->pib_hmte,CCHMAXPATH,exefile);
   dir = exefile + strlen(exefile);
  while (dir[0] != '\\') dir--;
  dir[1] = '\0';
  strcat( exefile, "RUNLYNX.CMD");

  /* does our runlynx.cmd script exist? */
  if (access( exefile, 0) != 0) {
    sprintf( msgtext, "%s%s%s %s %s%s %s %s",
                  "Error: cannot find script \"", exefile, "\".",
                  "Check that", argv[0], ".exe", "is in the directory where LYNx is installed",
                  "or that LYNX has been installed using the LYNXINST program.");
    msgbox( msgtext);
  }

  /* gather parameters */
  i = 1;
  while (i < argc) {
      sprintf( parms, "%s %s", parms, argv[i]);
     i++;
  }

  /* build the command line */
  sprintf (cmd, "%s %s %s", "START /C /WIN /MAX \"LYNX/2\"", exefile, parms);
  /* start RUNLYNX.CMD */
  system(cmd);
  /* Put the LYNX session in foreground */
  return switchto( "LYNX/2");
}

void presentation(char *pgm) {
  fprintf( stdout, "%s%s\n\n", pgm, ", Version 1.0");
  fprintf( stdout, "%s\n", "Author: Michel Such (msuch@free.fr)");
}

int switchto( char *sw_title) {
  HAB hab=0;
  SWBLOCK *pList;
  int nEntries, rc, okay, i, bufsize;

  nEntries = WinQuerySwitchList(hab, (SWBLOCK *)0, 0);
  if (nEntries == 0) {
    sprintf( msgtext, "%s %s", "Error: cannot switch to", sw_title);
    msgbox( msgtext);
  }

  bufsize = (nEntries * sizeof(SWENTRY)) + sizeof(HSWITCH);
  pList = (SWBLOCK *) malloc(bufsize);
  rc = WinQuerySwitchList(hab, pList, bufsize);
  if (rc == 0) {
    sprintf( msgtext, "%s %s", "Error: cannot switch to", sw_title);
    msgbox( msgtext);
  }

  okay = 0;
  for (i=0; (okay == 0) && (i<nEntries); i++) {
    if (strcmp(pList->aswentry[i].swctl.szSwtitle, sw_title)==0) {
      rc = WinSwitchToProgram(pList->aswentry[i].hswitch);
      if (rc == 0) okay++;
    }
  }
  if (okay == 0) {
    sprintf( msgtext, "%s %s", "Error: cannot switch to", sw_title);
    msgbox( msgtext);
  }
  return 0;
}

void os2title(char *title){
  static SWCNTRL sw;
  static HSWITCH hswitch;
  static PSWCNTRL psw = (PSWCNTRL) &sw;
  /* save current process title */
  hswitch = WinQuerySwitchHandle(0, getpid());
  WinQuerySwitchEntry(hswitch, psw);
  if(psw->uchVisibility) {
    strcpy(title, psw->szSwtitle);
  }
}

     void msgbox( char *msg){
       char title[120];
     HAB hab;
     HMQ hmq;
  PPIB ppib;
  PTIB ptib;

  DosGetInfoBlocks(&ptib,&ppib);
  if (ppib->pib_ultype == 2)          /* VIO */
     ppib->pib_ultype = 3;

  hab = WinInitialize(0);
  hmq = WinCreateMsgQueue(hab, 0);
  if (!hmq) {
    fprintf( stderr,"Cannot create a message queue\n");
    exit(2);
  }
  os2title( title);
  WinMessageBox(HWND_DESKTOP, 0,
     msg, title, 100, MB_OK|MB_MOVEABLE|MB_SYSTEMMODAL);
  WinDestroyMsgQueue(hmq);
  WinTerminate(hab);
  exit(2);
     }
